﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.IO;

namespace Prohlizec
{
    static class Program
    {
        public static string RootDir;
        public static string SelectedFile;
        public static string SelectedDir;
        
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            RootDir = "C:\\";
            SelectedFile = null;

            if (args.Length > 0)
            {
                if (Directory.Exists(args[0]))
                    RootDir = args[0];
                else if (File.Exists(args[0]))
                {
                    RootDir = GetDirFromFile(args[0]);
                    SelectedFile = args[0];
                }
            }

            SelectedDir = RootDir;
            
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new FileTree());
        }

        public static string GetDirFromFile(string fileName)
        {
            int i, iLength;

            if (!File.Exists(fileName))
                throw new Exception("string GetDirFromFile(string fileName): File does not exist!!!");

            iLength = fileName.Length;
            for (i = fileName.Length - 1; i >= 0; i--)
            {
                iLength--;
                if (fileName[i] == '\\')
                    break;
            }

            return fileName.Substring(0, iLength);
        }

        public static string GetPureFileName(string fileName)
        {
            int i, iStart;

            if (!File.Exists(fileName))
                throw new Exception("string GetPureFileName(string fileName): File does not exist!!!");

            iStart = fileName.Length;
            for (i = fileName.Length - 1; i >= 0; i--)
            {
                if (fileName[i] == '\\')
                    break;

                iStart--;
            }

            return fileName.Substring(iStart);
        }

        public static string GetPureDirName(string dirName)
        {
            int i, iStart;

            if (!Directory.Exists(dirName))
                throw new Exception("string GetPureDirName(string fileName): Directory does not exist!!!");

            iStart = dirName.Length;
            for (i = dirName.Length - 1; i >= 0; i--)
            {
                if (dirName[i] == '\\' && i < (dirName.Length - 1))
                    break;

                iStart--;
            }

            return dirName.Substring(iStart);
        }
    }
}
